using System;
using System.Globalization;
using System.Windows.Data;

namespace PlayParsingException
{
    public class StringToDoubleConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (targetType == typeof(double))
            {
                if (value is double) return value;

                if(value == null) throw new ArgumentNullException("value");

                var s = value as string;
                if (s != null) return double.Parse(s);

                throw new ArgumentException("Not handled type", "value");
            }

            if (targetType == typeof (string))
            {
                if (value is string) return value;

                if (value is double) return value.ToString();

                throw new ArgumentException("Not handled type", "value");
            }

            throw new ArgumentException("TargetType not supported " + targetType, "targetType");
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return Convert(value, targetType, parameter, culture);
        }
    }
}